summaryrefslogtreecommitdiffstats
path: root/u-boot-tools/build
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2012-03-05 11:30:14 +0000
committer Eric Hameleers <alien@slackware.com>2012-03-05 11:30:14 +0000
commitbe724ddfcb77728f17df1823209eda3a9ba536cd (patch)
tree1239f4b04afc782c38ceb36458bb1110bb13af31 /u-boot-tools/build
parent03051f7a03f6f95a82f60ce2cfccfa27d08b6718 (diff)
downloadasb-be724ddfcb77728f17df1823209eda3a9ba536cd.tar.gz
asb-be724ddfcb77728f17df1823209eda3a9ba536cd.tar.xz
Initial revision
Diffstat (limited to 'u-boot-tools/build')
-rw-r--r--u-boot-tools/build/slack-desc19
-rwxr-xr-xu-boot-tools/build/u-boot-tools.SlackBuild147
2 files changed, 166 insertions, 0 deletions
diff --git a/u-boot-tools/build/slack-desc b/u-boot-tools/build/slack-desc
new file mode 100644
index 00000000..b81b9e26
--- /dev/null
+++ b/u-boot-tools/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+u-boot-tools: u-boot-tools (Tools for systems using the Das U-Boot Linux Loader)
+u-boot-tools:
+u-boot-tools: This package contains the tools for working with a system that uses
+u-boot-tools: the Das U-Boot Linux loader. This includes the mkimage utility, which
+u-boot-tools: encapsulates a compressed "uImage" Linux kerel image with header
+u-boot-tools: information, CRC32 checksum and so on. mkimage can also be used to
+u-boot-tools: create ramdisk images for use with U-Boot, either separated from the
+u-boot-tools: Linux kernel image, or combined into one file.
+u-boot-tools:
+u-boot-tools: Also included are the tools to read and modify U-Boot's environment.
+u-boot-tools: For more information, visit: http://www.denx.de/wiki/U-Boot
diff --git a/u-boot-tools/build/u-boot-tools.SlackBuild b/u-boot-tools/build/u-boot-tools.SlackBuild
new file mode 100755
index 00000000..989f62fb
--- /dev/null
+++ b/u-boot-tools/build/u-boot-tools.SlackBuild
@@ -0,0 +1,147 @@
+#!/bin/sh
+
+# Copyright 2011 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PKGNAM=u-boot-tools
+SRCNAM=u-boot
+VERSION=${VERSION:-2011.12}
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+if [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+else
+ LIBDIRSUFFIX=""
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.?z* || exit 1
+cd $SRCNAM-$VERSION || exit 1
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Build the Sheevaplug configuration:
+case "$ARCH" in
+ arm*)
+ make sheevaplug_config
+ ;;
+ *)
+ ;;
+esac
+
+# Create files normally created by the cross-compiler
+touch include/autoconf.mk
+touch include/autoconf.mk.dep
+mkdir include/generated
+touch include/generated/generic-asm-offsets.h
+touch lib/asm-offsets.s
+touch {arch/arm/cpu/arm926ejs,examples/standalone,tools,tools/env}/.depend
+
+# Build the tools (not ARM specific):
+make tools HOSTCC="gcc $SLKCFLAGS" HOSTSTRIP=/bin/true CROSS_COMPILE=""
+
+case "$ARCH" in
+ arm*)
+ make env HOSTCC="gcc $SLKCFLAGS" CROSS_COMPILE=""
+ ;;
+ *)
+ ;;
+esac
+
+# Install the tools:
+mkdir -p $PKG/{etc,usr/bin,usr/man/man1}
+install -p -m 0755 tools/mkimage $PKG/usr/bin
+install -p -m 0644 doc/mkimage.1 $PKG/usr/man/man1
+
+case "$ARCH" in
+ arm*)
+ install -p -m 0755 tools/env/fw_printenv $PKG/usr/bin
+ ( cd $PKG/usr/bin ; ln -sf fw_printenv fw_setenv )
+ install -m 0644 tools/env/fw_env.config $PKG/etc/fw_env.config.new
+ cat <<-EOT >>$PKG/etc/fw_env.config.new
+
+ # This allows you to update the u-boot code from Linux.
+
+ # SheevaPlug offsets:
+ # /dev/mtd0 0xA0000 0x20000 0x20000
+
+ # GuruPlug offsets:
+ # /dev/mtd0 0x40000 0x20000 0x20000
+ EOT
+ ;;
+ *)
+ ;;
+esac
+
+# Strip binaries:
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
+cp -a \
+ COPYING* CREDITS MAINTAINERS README doc/README.imximage doc/README.kwbimage doc/uImage.FIT doc*.txt \
+ $PKG/usr/doc/$PKGNAM-$VERSION
+
+# Compress and fix manpage symlinks:
+if [ -d $PKG/usr/man ]; then
+ ( cd $PKG/usr/man
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.?
+ )
+ done
+ )
+fi
+
+mkdir -p $PKG/install
+zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz
+